<template>
  <div class="row w-100 p-0">
    <b-col v-if="hasInfo" md="3" class="pr-3">
      <div class="nav-project-outputs">
        <div class="d-none d-sm-inline-block w-100">
          <div class="subheader mt-1 mb-3">Titles</div>
          <div class="overflow-auto" style="height: 550px">
            <p
              v-for="(info, index) in reportInfo"
              :key="index"
              class="cursor-pointer"
              @click="changePage(info.uri)"
            >
              <TargetIcon class="icon-xxs" /> {{ info.title }}
            </p>
          </div>
        </div>
      </div>
    </b-col>
    <b-col :md="hasInfo ? '9' : '12'" class="p-0">
      <div class="card card-lg w-100 h-100">
        <div class="card-body p-3">
          <div class="row justify-content-center g-0">
            <div class="col">
              <h3 class="strong mb-0">
                <span>{{ outputReport.title }}</span>
              </h3>
              <p>{{ outputReport.description }}</p>
            </div>
            <div class="col col-auto mr-1">
              <div class="row justify-content-center g-3">
                <div class="col col-auto">
                  <span
                    class="small text-muted cursor-pointer"
                    @click="clearOutputReport()"
                  >
                    <ChevronLeftIcon class="icon-xxs" />
                    All outputs
                  </span>
                </div>
              </div>
            </div>
          </div>
          <MaximizeIcon
            class="icon-sm position-absolute mt-1 cursor-pointer"
            style="right: 3%"
            @click="openDiagram()"
          />
          <iframe
            class="w-full border-0"
            style="height: 500px"
            :src="uriReport"
          />
        </div>
      </div>
    </b-col>
  </div>
</template>

<script>
export default {
  props: {
    outputReport: {
      type: Object,
      default: () => {},
    },
  },
  data() {
    return {
      uriPage: '',
    };
  },
  computed: {
    uriReport() {
      return this.uriPage || this.outputReport.uri;
    },
    hasInfo() {
      return (
        this.outputReport &&
        this.outputReport.info &&
        this.outputReport.info.length > 0
      );
    },
    reportInfo() {
      return this.outputReport.info
        .split(';')
        .reduce(
          (previous, next) => [
            ...previous,
            ...[{ title: next.split('=')[0], uri: next.split('=')[1] }],
          ],
          []
        );
    },
  },
  beforeDestroy() {
    this.clearOutputReport();
  },
  methods: {
    clearOutputReport() {
      this.$store.commit('ui/setOutputReport', {});
    },
    changePage(uri) {
      this.uriPage = uri;
    },
    openDiagram() {
      window.open(this.uriReport, '_blank');
    },
  },
};
</script>
